#include <stdio.h>
#include <pwd.h>
#include <stddef.h>
#include <utmp.h>
#include <string.h>
#include <netdb.h>
#include <signal.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include "netlib.h"
#include "info.h"

#define BUFSIZE         65536

int s, s1;
char buf1[BUFSIZE];
char *buf;

static void sig_usr(int signo)        /* argument is signal number */
{
    close(s1);
    close(s);
    exit(-1);
}


int main(int argc, char** argv)
{
    char *service="finger";
    struct sockaddr_in addr, tsa;
    int addr_len, tsa_size;
    char buf[BUFSIZE];
    int n, m;
    char opt;
    char *answer;
    char *test;

    /* Uklid po ukonceni fingerd */
    if (signal(SIGUSR1, sig_usr) == SIG_ERR)
        perror("can't catch SIGUSR1");
    if (signal(SIGINT, sig_usr) == SIG_ERR)
        perror("can't catch SIGINT");
    if (signal(SIGQUIT, sig_usr) == SIG_ERR)
        perror("can't catch SIGQUIT");
    if (signal(SIGABRT, sig_usr) == SIG_ERR)
        perror("can't catch SIGABRT");

    s=listensock(service, 10);

    /* Pobezi to dokud se to neKILLne */
    while (1)
    {
        /*getsockname(s,&tsa,&tsa_size);
        printf("getsockname: IP: %s\n",inet_ntoa(tsa.sin_addr));
        printf("getsockname: PORT %4d\n",ntohs(tsa.sin_port));*/

        s1=accept(s, (struct sockaddr *) &addr, &addr_len);

        /* Nacteme pozadavek */
        n=read(s1, buf, BUFSIZE);
        if (n < 0)
        {
            perror("fingerd ");
            exit(1);
        }

        buf[n] = '\0';

        /* Zpracovani pozadavku podle formatu ktery ma byt zobrazen */
        opt = 'x';
        n = 0;
        if (buf[0] == '/' && buf[1] == 'W') {
            opt = 'l';
            n = 2;
        }
        else if (buf[0] == '-' && buf[1] == 's') {
            opt = 's';
            n = 2;
        }

        /* Preskoceni pripadnych mezer */
        while (buf[n] == ' ') n++;

        /* Nalezeni spravneho konce pozadavku (bez ukoncovacich znaku) */
        test = strchr(&buf[n], '\r');
        if (test != NULL)
            *test = '\0';
        else {
            test = strchr(&buf[n], '\n');
            if (test != NULL)
                *test = '\0';
        }

        /* Defaultni nastaveni formatu pokud neni specifikovan */
        if (opt == 'x')
        {
            if (buf[n] == '\0')
                opt = 's';
            else
                opt = 'l';
        }

        /* Volani funkce ktera vyhleda informace a zformatuje odpoved */
        answer = info (opt, buf + n);

        n = strlen(answer);

        /* Odeslani odpovedi zpet */
        write(s1, answer, n);

        close(s1);
    }

    close(s);
    exit(0);
}

char *info(char opt, char *name)
{
    char *bx;

    buf=buf1;

    /* Byl vybran kratky format */
    /*vypsani hlavicky pro kratky format*/
    if (opt == 's')
    {
        str_pr(buf,    "Login", 9);
        str_pr(buf+10, "Name", 17);
        str_pr(buf+28, "Tty", 6);
        str_pr(buf+35, "Login Time", 20);
        str_pr(buf+55, "Office", 12);
        str_pr(buf+67, "Office Phone", 13);
        buf[80] = '\n';
        buf += 81;
    }
    /* Pokud neni uvedeno jmeno hledam informace o prave prihlasenych */
    if (*name == '\0')
        all_info(opt);
    /* jinak hledam informace o danem uzivateli */
    else pass_info(opt, name);
    buf[0]='\0';

    return buf1;
}

void all_info(char opt)
{
    FILE *futmp;

    /* pro kazdeho uzivatele obsahuje 0 nebo 1 (pristup pres uid uzivatele) */
    char uid[BUFSIZE];

    /* Struktura zaznamu o prave prihlasenem uzivateli
     struct utmp {
     short ut_type;               type of login
     pid_t ut_pid;                pid of login process
     char ut_line[UT_LINESIZE];   device name of tty - "/dev/"
     char ut_id[4];               init id or abbrev. ttyname
     char ut_user[UT_NAMESIZE];   user name
     char ut_host[UT_HOSTSIZE];   hostname for remote login
     struct exit_status ut_exit;  The exit status of a process
     marked as DEAD_PROCESS.
     long ut_session;             session ID, used for windowing
     struct timeval ut_tv;        time entry was made.
     int32_t ut_addr_v6[4];       IP address of remote host.
     char pad[20];                Reserved for future use.
     };*/
    struct utmp d_utmp;

    /* Ukazatel na strukturu uzivatele v passwd
     struct passwd {
     char    *pw_name;        user name
     char    *pw_passwd;      user password
     uid_t   pw_uid;          user id
     gid_t   pw_gid;          group id
     char    *pw_gecos;       real name
     char    *pw_dir;         home directory
     char    *pw_shell;       shell program
     };*/
    struct passwd *ptr;

    char *i;

    /* nulovani uid */
    for (i=uid; i < uid+BUFSIZE; *i++=0);
    futmp=fopen("//var//run//utmp", "rb");

    /* nastavi ukazatel v passwd na zacatek */
    setpwent();

     while(feof(futmp) == 0)
    {
        fread(&d_utmp ,sizeof(d_utmp), 1, futmp);

        /* Vraci ukazatel na strukturu o uzivateli v passwd */
        ptr = getpwnam(d_utmp.ut_user);

        if (ptr == NULL) continue;

        /* pokud se uid[prt->pw_uid] == 1 uz jsme uzivatele jednou cetli,
           uzivatel ma otevrenych vice konzoli */
        if (uid[ptr->pw_uid] == 0)
        {
            uid[ptr->pw_uid]=1;
            pass_info(opt, d_utmp.ut_user);
        }
    }

    /* zavre soubor passwd */
    endpwent();

    fclose(futmp);
}

/* funkce vlepi do retezce dest retezec src o delce n */
void str_pr(char *dest, char *src, int n)
{
    int i;
    for(i=0; i<=n; i++)
    {
        /*je-li v kopirovanem retezci '\n' nahradi jej mezerou*/
        if(src[i] == '\n')
        {
            dest[i] = ' ';
            continue;
        }
        /*je-li v kopirovanem retezci '\0' nahradi jej mezerou*/
        if(src[i] == '\0')
        {
            dest[i] = ' ';
            break;
        }
        dest[i] = src[i];
    }
    /*doplneni retezce mazerama na pozadovanou velikost*/
    for(;i<=n; i++) dest[i] = ' ';
    dest[n]=' ';
}


void pass_info(char opt, char *name)
{
    FILE *futmp;
    struct utmp d_utmp;
    struct passwd *ptr;
    char usr_name[80];
    char usr_office[80];
    char usr_off_tel[80];
    char usr_home_tel[80];
    char x[256];
    char *ps1, *ps2;

    /* nastavi ukazatel v passwd na zacatek */
    setpwent();
    /*nastavi ukazatel na pozadovany zaznam*/
    ptr = getpwnam(name);
    if (ptr == NULL) return;

    /*ziskava udaje pro vypsani uzivatelskeho jmena, kancelare, telefonu
     do kancelare a domu ze struktury souboru /etc/passwd polozky pw_gecos*/
    /*ps2 ukazuje na konec prvniho udaje -uzvatel. jmeno*/
    ps2 = strchr(ptr->pw_gecos, ',');
    if (ps2 != NULL)
    {
        strncpy(usr_name, ptr->pw_gecos, ps2-ptr->pw_gecos);
        usr_name[ps2-ptr->pw_gecos]='\0';
        ps1 = ps2 + 1;
        ps2 = strchr(ps1, ',');
        /*ps2 ukazuje na konec druheho  udaje -office*/
        if (ps2 != NULL)
        {
            strncpy(usr_office, ps1, ps2-ps1);
            usr_office[ps2-ps1]='\0';
            ps1 = ps2 + 1;
            ps2 = strchr(ps1, ',');
            /*ps2 ukazuje na konec tretiho udaje -telefon do kancelare*/
            if (ps2 != NULL)
            {
                strncpy(usr_off_tel, ps1, ps2-ps1);
                usr_off_tel[ps2-ps1]='\0';
                ps1 = ps2 + 1;
                /*ps1 ukazuje na zacatel posledniho udaje -telefon domu*/
                strncpy(usr_home_tel, ps1, ptr->pw_gecos +
                        strlen(ptr->pw_gecos)-ps1);
                usr_home_tel[ptr->pw_gecos + strlen(ptr->pw_gecos)-ps1]='\0';
            }
        }
    }
    /*vypisuje ziskane informace do buf v zavislosti na zvolenem prepinaci*/
    switch(opt)
    {
    /*kratky vypis*/
    case  's':
        break;

    /*dlohy vypis*/
    case  'l':
        str_pr(buf, "Login: ", 9);
        str_pr(buf+9, ptr->pw_name, 31);
        str_pr(buf+40, "Name: ", 8);
        str_pr(buf+48, usr_name, 32);
        buf[80] = '\n';
        buf += 81;
        str_pr(buf, "Directory: ", 12);
        str_pr(buf+12,ptr->pw_dir, 28);
        str_pr(buf+40, "Shell: ", 9);
        str_pr(buf+49,ptr->pw_shell, 31);
        buf[80] = '\n';
        buf += 81;
        str_pr(buf, "Office: ", 9);
        sprintf(x, "%s, %s", usr_office, usr_off_tel);
        str_pr(buf+9, x, 31);
        str_pr(buf+40, "Home Phone: ", 13);
        str_pr(buf+53, usr_home_tel , 27);
        buf[80] = '\n';
        buf += 81;
        break;
    default:
        printf("nepovoleny prepinac");
        break;
    }
    /* zavre soubor passwd */
    endpwent();

    futmp=fopen("//var//run//utmp", "rb");
    while(feof(futmp) == 0)
    {
        fread(&d_utmp ,sizeof(d_utmp), 1, futmp);

        if (strcmp(name, d_utmp.ut_user) == 0 && d_utmp.ut_line[0] != 'p')
        {
            switch(opt)
            {
            /*vpisuje informace do buf*/
            case  's':
                str_pr(buf, ptr->pw_name, 10);
                str_pr(buf+10, usr_name, 18);
                str_pr(buf+28, d_utmp.ut_line+3, 7);
                str_pr(buf+35, ctime(&d_utmp.ut_tv.tv_sec), 20);
                str_pr(buf+55, usr_office, 12);
                str_pr(buf+67, usr_off_tel, 13);
                buf[80] = '\n';
                buf += 81;
                break;

                /*vpisuje zbyvajici informace do buf -doby prihlaseni a
                 zarizeni, na kterem je uzivatel prihlasen*/
            case  'l':
                str_pr(buf, "On since ", 9);
                str_pr(buf+9, ctime(&d_utmp.ut_tv.tv_sec), 26);
                str_pr(buf+35,"on " , 3);
                str_pr(buf+38,d_utmp.ut_line , 10);
                buf[48] = '\n';
                buf += 49;
                break;
            default:
                printf("nepovoleny prepinac");
                break;
            }
        }
    }
    if (opt=='l')
    {
        buf[0] = '\n';
        buf++;
    }

    /*uzavra soubor /var/run/utmp*/
    fclose(futmp);
}
